Index: palm/trunk/SOURCE/pres.f90
===================================================================
--- palm/trunk/SOURCE/pres.f90	(revision 4901)
+++ palm/trunk/SOURCE/pres.f90	(revision 1)
@@ -456,15 +298,38 @@
 !
 !-- Compute the pressure perturbation solving the Poisson equation
-    IF ( psolver == 'poisfft' )  THEN
+    IF ( psolver(1:7) == 'poisfft' )  THEN
+
+!
+!--    Enlarge the size of tend, used as a working array for the transpositions
+       IF ( nxra > nxr  .OR.  nyna > nyn  .OR.  nza > nz )  THEN
+          DEALLOCATE( tend )
+          ALLOCATE( tend(1:nza,nys:nyna,nxl:nxra) )
+       ENDIF
 
 !
 !--    Solve Poisson equation via FFT and solution of tridiagonal matrices
-       CALL poisfft( d )
-
-!
-!--    Store computed perturbation pressure and set boundary condition in z-direction
-       !$OMP PARALLEL DO PRIVATE (i,j,k) SCHEDULE( STATIC )
-       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
-       !$ACC PRESENT(d, tend)
+       IF ( psolver == 'poisfft' )  THEN
+!
+!--       Solver for 2d-decomposition
+          CALL poisfft( d, tend )
+       ELSEIF ( psolver == 'poisfft_hybrid' )  THEN 
+!
+!--       Solver for 1d-decomposition (using MPI and OpenMP).
+!--       The old hybrid-solver is still included here, as long as there
+!--       are some optimization problems in poisfft
+          CALL poisfft_hybrid( d )
+       ENDIF
+
+!
+!--    Resize tend to its normal size
+       IF ( nxra > nxr  .OR.  nyna > nyn  .OR.  nza > nz )  THEN
+          DEALLOCATE( tend )
+          ALLOCATE( tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+       ENDIF
+
+!
+!--    Store computed perturbation pressure and set boundary condition in
+!--    z-direction
+       !$OMP PARALLEL DO
        DO  i = nxl, nxr
           DO  j = nys, nyn
@@ -477,52 +342,37 @@
 !
 !--    Bottom boundary:
-!--    This condition is only required for internal output. The pressure gradient
-!--    (dp(nzb+1)-dp(nzb))/dz is not used anywhere else.
+!--    This condition is only required for internal output. The pressure
+!--    gradient (dp(nzb+1)-dp(nzb))/dz is not used anywhere else.
        IF ( ibc_p_b == 1 )  THEN
 !
-!--       Neumann (dp/dz = 0). Using surface data type, first for non-natural surfaces, then for
-!--       natural and urban surfaces
-!--       Upward facing
-          !$OMP PARALLEL DO PRIVATE( m, i, j, k ) SCHEDULE( STATIC )
-          !$ACC PARALLEL LOOP PRIVATE(i, j, k) &
-          !$ACC PRESENT(bc_h, tend)
-          DO  m = 1, bc_h(0)%ns
-             i = bc_h(0)%i(m)
-             j = bc_h(0)%j(m)
-             k = bc_h(0)%k(m)
-             tend(k-1,j,i) = tend(k,j,i)
-          ENDDO
-!
-!--       Downward facing
-          !$OMP PARALLEL DO PRIVATE( m, i, j, k ) SCHEDULE( STATIC )
-          !$ACC PARALLEL LOOP PRIVATE(i, j, k) &
-          !$ACC PRESENT(bc_h, tend)
-          DO  m = 1, bc_h(1)%ns
-             i = bc_h(1)%i(m)
-             j = bc_h(1)%j(m)
-             k = bc_h(1)%k(m)
-             tend(k+1,j,i) = tend(k,j,i)
+!--       Neumann (dp/dz = 0)
+          !$OMP PARALLEL DO
+          DO  i = nxl-1, nxr+1
+             DO  j = nys-1, nyn+1
+                tend(nzb_s_inner(j,i),j,i) = tend(nzb_s_inner(j,i)+1,j,i)
+             ENDDO
+          ENDDO
+
+       ELSEIF ( ibc_p_b == 2 )  THEN
+!
+!--       Neumann condition for inhomogeneous surfaces,
+!--       here currently still in the form of a zero gradient. Actually 
+!--       dp/dz = -(dtau13/dx + dtau23/dy) + g*pt'/pt0 would have to be used for
+!--       the computation (cf. above: computation of divergences).
+          !$OMP PARALLEL DO
+          DO  i = nxl-1, nxr+1
+             DO  j = nys-1, nyn+1
+                tend(nzb_s_inner(j,i),j,i) = tend(nzb_s_inner(j,i)+1,j,i)
+             ENDDO
           ENDDO
 
        ELSE
 !
-!--       Dirichlet. Using surface data type, first for non-natural surfaces, then for natural and
-!--       urban surfaces
-!--       Upward facing
-          !$OMP PARALLEL DO PRIVATE( m, i, j, k ) SCHEDULE( STATIC )
-          DO  m = 1, bc_h(0)%ns
-             i = bc_h(0)%i(m)
-             j = bc_h(0)%j(m)
-             k = bc_h(0)%k(m)
-             tend(k-1,j,i) = 0.0_wp
-          ENDDO
-!
-!--       Downward facing
-          !$OMP PARALLEL DO PRIVATE( m, i, j, k ) SCHEDULE( STATIC )
-          DO  m = 1, bc_h(1)%ns
-             i = bc_h(1)%i(m)
-             j = bc_h(1)%j(m)
-             k = bc_h(1)%k(m)
-             tend(k+1,j,i) = 0.0_wp
+!--       Dirichlet
+          !$OMP PARALLEL DO
+          DO  i = nxl-1, nxr+1
+             DO  j = nys-1, nyn+1
+                tend(nzb_s_inner(j,i),j,i) = 0.0
+             ENDDO
           ENDDO
 
@@ -534,7 +384,7 @@
 !
 !--       Neumann
-          !$OMP PARALLEL DO PRIVATE (i,j) SCHEDULE( STATIC )
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
+          !$OMP PARALLEL DO
+          DO  i = nxl-1, nxr+1
+             DO  j = nys-1, nyn+1
                 tend(nzt+1,j,i) = tend(nzt,j,i)
              ENDDO
@@ -544,10 +394,8 @@
 !
 !--       Dirichlet
-          !$OMP PARALLEL DO PRIVATE (i,j) SCHEDULE( STATIC )
-          !$ACC PARALLEL LOOP COLLAPSE(2) PRIVATE(i, j) &
-          !$ACC PRESENT(tend)
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
-                tend(nzt+1,j,i) = 0.0_wp
+          !$OMP PARALLEL DO
+          DO  i = nxl-1, nxr+1
+             DO  j = nys-1, nyn+1
+                tend(nzt+1,j,i) = 0.0
              ENDDO
           ENDDO
@@ -557,258 +405,214 @@
 !
 !--    Exchange boundaries for p
-       CALL exchange_horiz( tend, nbgp )
-
+       CALL exchange_horiz( tend, 0, 0 )
+      
     ELSEIF ( psolver == 'sor' )  THEN
 
 !
-!--    Solve Poisson equation for perturbation pressure using SOR-Red/Black scheme
-       CALL sor( d, ddzu_pres, ddzw, p_loc )
-       tend = p_loc
-
-    ELSEIF ( psolver(1:9) == 'multigrid' )  THEN
-
-!
-!--    Solve Poisson equation for perturbation pressure using Multigrid scheme, array tend is used
-!--    to store the residuals.
-
-!--    If the number of grid points of the gathered grid, which is collected on PE0, is larger than
-!--    the number of grid points of an PE, than array tend will be enlarged.
-       IF ( gathered_size > subdomain_size )  THEN
-          DEALLOCATE( tend )
-          ALLOCATE( tend(nzb:nzt_mg(mg_switch_to_pe0_level)+1,nys_mg(                              &
-                    mg_switch_to_pe0_level)-1:nyn_mg(mg_switch_to_pe0_level)+1,                    &
-                    nxl_mg(mg_switch_to_pe0_level)-1:nxr_mg(mg_switch_to_pe0_level)+1) )
-       ENDIF
-
-       IF ( psolver == 'multigrid' )  THEN
-          CALL poismg( tend )
-       ELSE
-          CALL poismg_noopt( tend )
-       ENDIF
-
-       IF ( gathered_size > subdomain_size )  THEN
-          DEALLOCATE( tend )
-          ALLOCATE( tend(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-       ENDIF
-
-!
-!--    Restore perturbation pressure on tend because this array is used further below to correct the
-!--    velocity fields
-       DO  i = nxl-1, nxr+1
+!--    Solve Poisson equation for perturbation pressure using SOR-Red/Black
+!--    scheme
+       CALL sor( d, ddzu, ddzw, p )
+       tend = p
+
+    ELSEIF ( psolver == 'multigrid' )  THEN
+
+!
+!--    Solve Poisson equation for perturbation pressure using Multigrid scheme,
+!--    array tend is used to store the residuals
+       CALL poismg( tend )
+ 
+!
+!--    Restore perturbation pressure on tend because this array is used
+!--    further below to correct the velocity fields
+       tend = p
+
+    ENDIF
+
+!
+!-- Store perturbation pressure on array p, used in the momentum equations
+    IF ( psolver(1:7) == 'poisfft' )  THEN
+!
+!--    Here, only the values from the left and right boundaries are copied
+!--    The remaining values are copied in the following loop due to speed
+!--    optimization
+       !$OMP PARALLEL DO
+       DO  j = nys-1, nyn+1
+          DO  k = nzb, nzt+1
+             p(k,j,nxl-1) = tend(k,j,nxl-1)
+             p(k,j,nxr+1) = tend(k,j,nxr+1)
+          ENDDO
+       ENDDO
+    ENDIF
+
+!
+!-- Correction of the provisional velocities with the current perturbation 
+!-- pressure just computed
+    IF ( bc_lr /= 'cyclic'  .OR.  bc_ns /= 'cyclic' )  uvmean_outflow_l = 0.0
+    IF ( conserve_volume_flow )  THEN
+       volume_flow_l(1) = 0.0
+       volume_flow_l(2) = 0.0
+    ENDIF
+    !$OMP PARALLEL PRIVATE (i,j,k)
+    !$OMP DO
+    DO  i = nxl, nxr
+       IF ( psolver(1:7) == 'poisfft' )  THEN
           DO  j = nys-1, nyn+1
              DO  k = nzb, nzt+1
-                tend(k,j,i) = p_loc(k,j,i)
-             ENDDO
-          ENDDO
-       ENDDO
+                p(k,j,i) = tend(k,j,i)
+             ENDDO
+          ENDDO
+       ENDIF
+       DO  j = nys, nyn
+          DO  k = nzb_w_inner(j,i)+1, nzt
+             w(k,j,i) = w(k,j,i) - dt_3d * &
+                                   ( tend(k+1,j,i) - tend(k,j,i) ) * ddzu(k+1)
+          ENDDO
+          DO  k = nzb_u_inner(j,i)+1, nzt
+             u(k,j,i) = u(k,j,i) - dt_3d * ( tend(k,j,i) - tend(k,j,i-1) ) * ddx
+          ENDDO
+          DO  k = nzb_v_inner(j,i)+1, nzt
+             v(k,j,i) = v(k,j,i) - dt_3d * ( tend(k,j,i) - tend(k,j-1,i) ) * ddy
+          ENDDO
+
+!
+!--       Sum up the horizontal velocity along the outflow plane (in case
+!--       of non-cyclic boundary conditions). The respective mean velocity
+!--       is calculated from this in routine boundary_conds.
+          IF ( outflow_l  .AND.  i == nxl )  THEN
+             !$OMP CRITICAL
+             DO  k = nzb, nzt+1
+                uvmean_outflow_l(k) = uvmean_outflow_l(k) + v(k,j,nxl)
+             ENDDO
+             !$OMP END CRITICAL
+          ELSEIF ( outflow_r  .AND.  i == nxr )  THEN
+             !$OMP CRITICAL
+             DO  k = nzb, nzt+1
+                uvmean_outflow_l(k) = uvmean_outflow_l(k) + v(k,j,nxr)
+             ENDDO
+             !$OMP END CRITICAL
+          ELSEIF ( outflow_s  .AND.  j == nys )  THEN
+             !$OMP CRITICAL
+             DO  k = nzb, nzt+1
+                uvmean_outflow_l(k) = uvmean_outflow_l(k) + u(k,nys,i)
+             ENDDO
+             !$OMP END CRITICAL
+          ELSEIF ( outflow_n  .AND.  j == nyn )  THEN
+             !$OMP CRITICAL
+             DO  k = nzb, nzt+1
+                uvmean_outflow_l(k) = uvmean_outflow_l(k) + u(k,nyn,i)
+             ENDDO
+             !$OMP END CRITICAL
+          ENDIF
+
+!
+!--       Sum up the volume flow through the right and north boundary
+          IF ( conserve_volume_flow  .AND.  i == nx )  THEN
+             !$OMP CRITICAL
+             DO  k = nzb_2d(j,i) + 1, nzt
+                volume_flow_l(1) = volume_flow_l(1) + u(k,j,i) * dzu(k)
+             ENDDO
+             !$OMP END CRITICAL
+          ENDIF
+          IF ( conserve_volume_flow  .AND.  j == ny )  THEN
+             !$OMP CRITICAL
+             DO  k = nzb_2d(j,i) + 1, nzt
+                volume_flow_l(2) = volume_flow_l(2) + v(k,j,i) * dzu(k)
+             ENDDO
+             !$OMP END CRITICAL
+          ENDIF
+
+       ENDDO
+    ENDDO
+    !$OMP END PARALLEL
+
+!
+!-- Conserve the volume flow
+    IF ( conserve_volume_flow )  THEN
+
+#if defined( __parallel )   
+       CALL MPI_ALLREDUCE( volume_flow_l(1), volume_flow(1), 2, MPI_REAL, &
+                           MPI_SUM, comm2d, ierr )  
+#else
+       volume_flow = volume_flow_l  
+#endif   
+
+       volume_flow_offset = ( volume_flow_initial - volume_flow ) / &
+                            volume_flow_area
+
+       !$OMP PARALLEL PRIVATE (i,j,k)
+       !$OMP DO
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb_u_inner(j,i) + 1, nzt
+                u(k,j,i) = u(k,j,i) + volume_flow_offset(1)
+             ENDDO
+             DO  k = nzb_v_inner(j,i) + 1, nzt
+                v(k,j,i) = v(k,j,i) + volume_flow_offset(2)
+             ENDDO
+          ENDDO
+       ENDDO
+       !$OMP END PARALLEL
 
     ENDIF
 
 !
-!-- Store perturbation pressure on array p, used for pressure data output.
-!-- Ghost layers are added in the output routines (except sor-method: see below)
-    IF ( intermediate_timestep_count <= 1 )  THEN
-       !$OMP PARALLEL DO PRIVATE (i,j,k) SCHEDULE( STATIC )
-       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
-       !$ACC PRESENT(p, tend)
-       DO  i = nxl-1, nxr+1
-          DO  j = nys-1, nyn+1
-             DO  k = nzb, nzt+1
-                p(k,j,i) = tend(k,j,i) * weight_substep_l
-             ENDDO
-          ENDDO
-       ENDDO
-
-    ELSEIF ( intermediate_timestep_count > 1 )  THEN
-       !$OMP PARALLEL DO PRIVATE (i,j,k) SCHEDULE( STATIC )
-       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
-       !$ACC PRESENT(p, tend)
-       DO  i = nxl-1, nxr+1
-          DO  j = nys-1, nyn+1
-             DO  k = nzb, nzt+1
-                p(k,j,i) = p(k,j,i) + tend(k,j,i) * weight_substep_l
-             ENDDO
-          ENDDO
-       ENDDO
-
-    ENDIF
-
-!
-!-- SOR-method needs ghost layers for the next timestep
-    IF ( psolver == 'sor' )  CALL exchange_horiz( p, nbgp )
-
-!
-!-- Correction of the provisional velocities with the current perturbation pressure just computed
-    IF ( conserve_volume_flow  .AND.  ( bc_lr_cyc .OR. bc_ns_cyc ) )  THEN
-       volume_flow_l(1) = 0.0_wp
-       volume_flow_l(2) = 0.0_wp
-    ENDIF
-!
-!-- Add pressure gradients to the velocity components. Note, the loops are running over the entire
-!-- model domain, even though, in case of non-cyclic boundaries u- and v-component are not
-!-- prognostic at i=0 and j=0, respectiveley. However, in case of Dirichlet boundary conditions for
-!-- the velocities, zero-gradient conditions for the pressure are set, so that no modification is
-!-- imposed at the boundaries.
-    !$OMP PARALLEL DO PRIVATE (i,j,k) SCHEDULE( STATIC )
-    !$ACC PARALLEL LOOP COLLAPSE(2) PRIVATE(i, j, k) &
-    !$ACC PRESENT(u, v, w, tend, ddzu, wall_flags_total_0)
+!-- Exchange of boundaries for the velocities
+    CALL exchange_horiz( u, uxrp,    0 )
+    CALL exchange_horiz( v,    0, vynp )
+    CALL exchange_horiz( w,    0,    0 )
+
+!
+!-- Compute the divergence of the corrected velocity field,
+!-- a possible PE-sum is computed in flow_statistics 
+    CALL cpu_log( log_point_s(1), 'divergence', 'start' )
+    sums_divnew_l = 0.0
+
+!
+!-- d must be reset to zero because it can contain nonzero values below the
+!-- topography
+    IF ( topography /= 'flat' )  d = 0.0
+
+    localsum  = 0.0
+    threadsum = 0.0
+
+    !$OMP PARALLEL PRIVATE (i,j,k) FIRSTPRIVATE(threadsum) REDUCTION(+:localsum)
+    !$OMP DO SCHEDULE( STATIC )
+#if defined( __ibm )
     DO  i = nxl, nxr
        DO  j = nys, nyn
-
+          DO  k = nzb_s_inner(j,i)+1, nzt
+             d(k,j,i) = ( u(k,j,i+1) - u(k,j,i) ) * ddx + &
+                        ( v(k,j+1,i) - v(k,j,i) ) * ddy + &
+                        ( w(k,j,i) - w(k-1,j,i) ) * ddzw(k)
+          ENDDO
           DO  k = nzb+1, nzt
-             w(k,j,i) = w(k,j,i) - dt_3d * ( tend(k+1,j,i) - tend(k,j,i) ) * ddzu(k+1)             &
-                        * weight_pres_l                                                            &
-                        * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 3 ) )
-          ENDDO
-
-          DO  k = nzb+1, nzt
-             u(k,j,i) = u(k,j,i) - dt_3d * ( tend(k,j,i) - tend(k,j,i-1) ) * ddx * weight_pres_l   &
-                        * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 1 ) )
-          ENDDO
-
-          DO  k = nzb+1, nzt
-             v(k,j,i) = v(k,j,i) - dt_3d * ( tend(k,j,i) - tend(k,j-1,i) ) * ddy * weight_pres_l   &
-                        * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 2 ) )
-          ENDDO
-
+             threadsum = threadsum + ABS( d(k,j,i) )
+          ENDDO
        ENDDO
     ENDDO
-
-!
-!-- The vertical velocity is not set to zero at nzt + 1 for nested domains. Instead it is set to the
-!-- values of nzt (see routine vnest_boundary_conds or pmci_interp_tril_t) BEFORE calling the
-!-- pressure solver. To avoid jumps while plotting profiles, w at the top has to be set to the
-!-- values in height nzt after above modifications. Hint: w level nzt+1 does not impact results.
-    IF ( child_domain  .OR.  coupling_mode == 'vnested_fine' )  THEN
-       w(nzt+1,:,:) = w(nzt,:,:)
-    ENDIF
-
-!
-!-- Sum up the volume flow through the right and north boundary
-    IF ( conserve_volume_flow  .AND.  bc_lr_cyc  .AND.  bc_ns_cyc  .AND.  nxr == nx )  THEN
-       threadsum = 0.0_wp
-!
-!--    Summation of the volume flow is done on threadsum rather than on volumen_flow itself.
-!--    This is because intel compiler, when compiled with openmp, do not allow reduction
-!--    operation on array elements.
-       !$OMP PARALLEL DO PRIVATE (j,k) REDUCTION (+:threadsum)
+#else
+    DO  i = nxl, nxr
        DO  j = nys, nyn
-          DO  k = nzb+1, nzt
-             threadsum = threadsum + u(k,j,nxr) * dzw(k)                             &
-                                * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,nxr), 1 ) )
-          ENDDO
-       ENDDO
-       volume_flow_l(1) = threadsum
-
-    ENDIF
-
-    IF ( conserve_volume_flow  .AND.  bc_ns_cyc  .AND.  bc_lr_cyc  .AND. nyn == ny )  THEN
-       threadsum = 0.0_wp
-       !$OMP PARALLEL DO PRIVATE (j,k) REDUCTION (+:threadsum)
-       DO  i = nxl, nxr
-          DO  k = nzb+1, nzt
-             threadsum = threadsum + v(k,nyn,i) * dzw(k)                             &
-                                * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,nyn,i), 2 ) )
-           ENDDO
-       ENDDO
-       volume_flow_l(2) = threadsum
-
-    ENDIF
-
-!
-!-- Conserve the volume flow
-    IF ( conserve_volume_flow  .AND.  ( bc_lr_cyc  .AND.  bc_ns_cyc ) )  THEN
-
-#if defined( __parallel )
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( volume_flow_l(1), volume_flow(1), 2, MPI_REAL, MPI_SUM, comm2d, ierr )
-#else
-       volume_flow = volume_flow_l
+          DO  k = nzb_s_inner(j,i)+1, nzt
+             d(k,j,i) = ( u(k,j,i+1) - u(k,j,i) ) * ddx + &
+                        ( v(k,j+1,i) - v(k,j,i) ) * ddy + &
+                        ( w(k,j,i) - w(k-1,j,i) ) * ddzw(k)
+             threadsum = threadsum + ABS( d(k,j,i) )
+          ENDDO
+       ENDDO
+    ENDDO
 #endif
-
-       volume_flow_offset(1:2) = ( volume_flow_initial(1:2) - volume_flow(1:2) )                   &
-                                 / volume_flow_area(1:2)
-
-       !$OMP PARALLEL DO PRIVATE (i,j,k) SCHEDULE( STATIC )
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             DO  k = nzb+1, nzt
-                u(k,j,i) = u(k,j,i) + volume_flow_offset(1)                                        &
-                           * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 1 ) )
-             ENDDO
-             DO  k = nzb+1, nzt
-                v(k,j,i) = v(k,j,i) + volume_flow_offset(2)                                        &
-                           * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 2 ) )
-             ENDDO
-          ENDDO
-       ENDDO
-
-    ENDIF
-
-!
-!-- Exchange of boundaries for the velocities
-    CALL exchange_horiz( u, nbgp )
-    CALL exchange_horiz( v, nbgp )
-    CALL exchange_horiz( w, nbgp )
-
-!
-!-- Compute the divergence of the corrected velocity field.
-!-- A possible PE-sum is computed in flow_statistics. Carry out computation only at last
-!-- Runge-Kutta step.
-    IF ( intermediate_timestep_count == intermediate_timestep_count_max  .OR.                      &
-         intermediate_timestep_count == 0 )  THEN
-       CALL cpu_log( log_point_s(1), 'divergence', 'start' )
-       sums_divnew_l = 0.0_wp
-
-!
-!--    d must be reset to zero because it can contain nonzero values below the topography
-       IF ( topography /= 'flat' )  d = 0.0_wp
-
-       localsum  = 0.0_wp
-       threadsum = 0.0_wp
-
-       !$OMP PARALLEL PRIVATE (i,j,k) FIRSTPRIVATE(threadsum) REDUCTION(+:localsum)
-       !$OMP DO SCHEDULE( STATIC )
-       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
-       !$ACC PRESENT(u, v, w, rho_air, rho_air_zw, ddzw, wall_flags_total_0) &
-       !$ACC PRESENT(d)
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             DO  k = nzb+1, nzt
-                d(k,j,i) = ( ( u(k,j,i+1) - u(k,j,i) ) * rho_air(k) * ddx +    &
-                             ( v(k,j+1,i) - v(k,j,i) ) * rho_air(k) * ddy +    &
-                             ( w(k,j,i)   * rho_air_zw(k) - w(k-1,j,i) * rho_air_zw(k-1) )         &
-                             * ddzw(k) )                                                           &
-                           * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
-             ENDDO
-          ENDDO
-       ENDDO
-!
-!--    Compute possible PE-sum of divergences for flow_statistics
-       !$OMP DO SCHEDULE( STATIC )
-       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
-       !$ACC REDUCTION(+:threadsum) COPY(threadsum) &
-       !$ACC PRESENT(d)
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             DO  k = nzb+1, nzt
-                threadsum = threadsum + ABS( d(k,j,i) )
-             ENDDO
-          ENDDO
-       ENDDO
-
-       localsum = localsum + threadsum
-       !$OMP END PARALLEL
-
-!
-!--    For completeness, set the divergence sum of all statistic regions to those of the total
-!--    domain
-       sums_divnew_l(0:statistic_regions) = localsum
-
-       CALL cpu_log( log_point_s(1), 'divergence', 'stop' )
-
-    ENDIF
+    localsum = localsum + threadsum
+    !$OMP END PARALLEL
+
+!
+!-- For completeness, set the divergence sum of all statistic regions to those
+!-- of the total domain
+    sums_divnew_l(0:statistic_regions) = localsum
+
+    CALL cpu_log( log_point_s(1), 'divergence', 'stop' )
 
     CALL cpu_log( log_point(8), 'pres', 'stop' )
 
+
  END SUBROUTINE pres
